<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <title>Task 31.30</title>
</head>
<style>
    .picture-cover {
    background-image: url(LuckyDiceImages/cover.jpg);
    min-height: 100px;
    margin: 5px;
}
</style>
<body>
    <div class="container-fluid">
        <div class="picture-cover"></div>
    </div>
    <div class="container">
        <div class="row ">
            <div class="col-sm-5">
                <div class="row form-group">
                    <div class="col-12">
                        <h4>Nhập thông tin của bạn</h4>
                    </div>
                </div>

                <div class="row form-group">
                    <div class="col-4">
                        <label>Username</label>
                    </div>
                    <div class="col-8">
                        <input id="inp-user-name" class="form-control" type="text">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-4 ">
                        <label>Firstname</label>
                    </div>
                    <div class="col-8 ">
                        <input id="inp-first-name" class="form-control" type="text">
                    </div>
                </div>

                <div class="row form-group">
                    <div class="col-4">
                        <label>Lastname</label>
                    </div>
                    <div class="col-8 ">
                        <input id="inp-last-name" class="form-control" type="text">
                    </div>
                </div>

                <div class="row form-group">
                    <div class="col-4">
                        <label></label>
                    </div>
                    <div class="col-8">
                        <p id="p-notification-validate"></p>
                    </div>
                </div>
            </div>
            <div class="col-sm-4 text-center ">
                <div class="row form-group">
                    <div class="col-12">
                        <input id="btn-dice" class="btn btn-success button-width w-75" value="Ném" type="button">
                    </div>
                </div>

                <div class="row form-group">
                    <div class="col-12 ">
                        <img id="img-dice" class="img-thumbnail" src="LuckyDiceImages/dice.png">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12">
                        <p id="p-notification-dice">Chúc mừng</p>
                    </div>
                </div>

            </div>
            <div class="col-sm-3 text-center">
                <div class="row form-group">
                    <div class="col-12 ">
                        <p>Voucher</p>
                        <p id="p-voucher-id">No ID</p>
                        <p id="p-voucher-percent">0%</p>
                    </div>
                </div>

                <div class="row form-group">
                    <div class="col-12">
                        <img id="img-present" class="img-thumbnail" src="LuckyDiceImages/no-present.jpg">
                    </div>
                </div>
            </div>
        </div>
        <div class="form-group">
            <div class="row text-center">
                <div class="col-12 ">
                    <input id="btn-dice-history"  class="btn btn-primary button-width w-25" value="Dice History" type="button">
                    <input id="btn-voucher-history" class="btn btn-primary button-width w-25" value="Voucher History" type="button">
                    <input id="btn-present-history" class="btn btn-primary button-width w-25" value="Present History" type="button">
                </div>
            </div>
        </div>

        <div class="row ">
            <div class="col-12 ">
                <table id="history-placeholder-table" class="table table-striped table-hover border">
                    <tbody><tr>
                        <th>Lượt</th>
                        <th>Dice</th>
                    </tr>
                    
                </tbody></table>
            </div>
        </div>
    </div>
</body>
<script>
    "use strict"
    const gUSER = {
        userName:"",
        firstName:"",
        lastName:""
    }
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "/devcamp-lucky-dice/dice";
    const gUTF8_TEXT_APPLICATION_HEADER = "application/json;charset=UTF-8";
    const gEND_ROW = -1;
    const gTURN = 0;
    const gDICE = 1;

    $(document).ready(function(){
        $("#btn-dice").click(function(){
            onNemClick();
        });z
    })
    function onNemClick(){
        console.log("Clicked")
        //b1: thu thập dữ liệu user 
        getDataUser(gUSER);
        //b2: validate dữ liệu
        var vDuLieuHopLe = validateDataUser(gUSER);
        if(vDuLieuHopLe == true){
        //b3: call API dice
        callAPINewDice(gUSER);
        //b4: xử lý hiển thị
        }
    }

    function onDiceHistoryClick(){
        console.log("nút lịch sử dice được ấn");
        getDataUser(gUSER);
        var vDuLieuHopLe = validateDataUser(gUSER);
        if (vDuLieuHopLe == true){

            callAPIDiceHistory(gUSER);
        }
    }

    function getDataUser(paramInput){
        paramInput.userName = $("#inp-user-name").val().trim();
        paramInput.firstName = $("#inp-first-name").val().trim();
        paramInput.lastName = $("#inp-last-name").val().trim();
    }
    function validateDataUser(paramInput){
        if(paramInput.userName ==""){
            alert("Vui lòng nhập User Name");
            return false;
        }
        if(paramInput.firstName ==""){
            alert("Vui lòng nhập First Name");
            return false;
        }
        if(paramInput.lastName ==""){
            alert("Vui lòng nhập Last Name");
            return false;
        }
        return true;
    }
    function callAPINewDice(paramUser, paramXmlHttp){
        var paramXmlHttp = new XMLHttpRequest();
        paramXmlHttp.open("POST", gBASE_URL + "/dice", true);
        paramXmlHttp.setRequestHeader("Content-Type", gUTF8_TEXT_APPLICATION_HEADER);
        paramXmlHttp.send(JSON.stringify(paramUser));  //chuyển Json object sang string

        paramXmlHttp.onreadystatechange = function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {  //nếu trạng thái của response ready và ok
                //hãy REFACTORING ĐẨY MÃ NGUỒN XỬ LÝ RA FUNCTION KHÁC
                console.log(paramXmlHttp.responseText);
                // parsing to object
                var vResponse = JSON.parse(paramXmlHttp.responseText);
                // get result dice
                var vDiceReady = vResponse.dice;
                console.log("dice result: " + vDiceReady);
                var vVoucher = vResponse.voucher;
                console.log("%c voucher: ", "color: yellow");
                console.log(vVoucher);
                console.log("%c prize: ", "color: yellow");
                console.log(vResponse.prize);
                changeDiceImage(vDiceReady);
                changeNotification(vDiceReady);
                displayVoucher(vVoucher);
                var vPrize = vResponse.prize
                displayPrize(vPrize);
            }
        }
    }
   
    //hàm thay đổi hình dice
    function changeDiceImage(paramDice){
        if(paramDice === 1 ){
            $("#img-dice").prop("src","LuckyDiceImages/1.png")
        }
        else if(paramDice ===2){
            $("#img-dice").prop("src","LuckyDiceImages/2.png")
        }
        else if(paramDice ===3){
            $("#img-dice").prop("src","LuckyDiceImages/3.png")
        }
        else if(paramDice ===4){
            $("#img-dice").prop("src","LuckyDiceImages/4.png")
        }
        else if(paramDice ===5){
            $("#img-dice").prop("src","LuckyDiceImages/5.png")
        }
        else if(paramDice ===6){
            $("#img-dice").prop("src","LuckyDiceImages/6.png")
        }
    }
    function changeNotification(paramDice){
        if(paramDice < 4){
            $("#p-notification-dice").html("Chúc may mắn lần sau");
        }
        else{
            $("#p-notification-dice").html("Chúc mừng, bạn thật may mắn");
        }
    }
    function displayVoucher(paramVoucher){
        if( paramVoucher != null){
            $("#p-voucher-id").html("ID Voucher: " + paramVoucher.maVoucher);
            $("#p-voucher-percent").html("Giảm giá: " + paramVoucher.phanTramGiamGia + "%");
        }
        else{
            $("#p-voucher-id").html("không có voucher");
            $("#p-voucher-percent").html("0%");
        }
    }
    function displayPrize(paramPrize){
        
        if (paramPrize === "Mũ"){
            $("#img-present").prop("src","LuckyDiceImages/hat.jpg");
        }
        else if(paramPrize === "Sổ"){
            $("#img-present").prop("src","LuckyDiceImages/sổ.jfif");
        }
        else if(paramPrize === "Bút"){
            $("#img-present").prop("src","LuckyDiceImages/bút.jfif")
        }
        else if(paramPrize === "Áo mưa"){
            $("#img-present").prop("src","LuckyDiceImages/áo-mưa.jfif")
        }
        else if(paramPrize === "Xe máy"){
            $("#img-present").prop("src","LuckyDiceImages/xe-may.jpg")
        }
        else if(paramPrize === null){
            $("#img-present").prop("src","LuckyDiceImages/no-present.jpg")
        }
    }

</script>
</html>